<template>
  <div>
    <v-dialog
      width="50%"
      height="auto"
      v-model="selectedValue"
      name="edit_client"
    >
      <v-card>
        <v-card-title class="light">Modifiko Grupin</v-card-title>
        <v-container>
          <v-row class="mx-2">
            <v-col class="justify-space-between" cols="6">
              <v-text-field label="Emri*" v-model="request.name" />
            </v-col>
            <v-col cols="6">
              <price-list-select v-model="request.price_list_type_id" />
            </v-col>
          </v-row>
        </v-container>
        <v-card-actions>
          <v-spacer />
          <v-btn text @click="close">Anullo</v-btn>
          <f-submit-btn
            @click="submit"
            :loading="loading"
            :disabled="loading"
          />
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>
<script lang="ts">
import Vue from 'vue'
import api from '../../../../plugins/api'
import { Component, Watch, Prop } from 'vue-property-decorator'
import eventBus from '../../../../plugins/event-bus'
import FSubmitBtn from '../../../../components/buttons/FSubmitBtn.vue'
import PriceListSelect from '../../../../components/selects/PriceListSelect.vue'
@Component({
  components: { PriceListSelect, FSubmitBtn },
})
export default class EditClientGroup extends Vue {
  @Prop({ type: Boolean, required: true }) value
  @Prop({ type: Object, required: true }) clientGroup
  @Prop({ type: String }) label
  @Watch('label')
  onLabelChange(newValue) {
    this.request.name = newValue
  }
  @Watch('clientGroup')
  OnClientGroupChange(newValue) {
    this.request.price_list_type_id = newValue.data.price_list_type_id
  }
  request = {
    name: '',
    margin: 0,
    price_list_type_id: null,
  }
  loading = false

  get selectedValue() {
    return this.value
  }
  set selectedValue(newValue) {
    this.$emit('input', newValue)
  }

  close() {
    this.selectedValue = false
    this.request.name = this.label
  }
  submit() {
    const id = this.clientGroup.id
    this.loading = true
    api()
      .put(`/api/crm/client-groups/${id}`, this.request)
      .then(response => {
        alert(response.data.message)
        this.selectedValue = false

        eventBus.$emit('refresh')
      })
      .catch(error => {
        alert(error.message)
      })
      .finally(() => {
        this.loading = false
      })
  }
}
</script>
